;;; $Id: cell-mod.tst,v 1.2 2006/01/05 22:24:09 leavens Exp $

(require (lib "cell-mod.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (cell? (cell 3)) ==> #t )
    ( (cell? 3) ==> #f )

    ( ((cell-of number?) (cell 3)) ==> #t )
    ( ((cell-of boolean?) (cell 3)) ==> #f )

    ( (cell-ref (cell 3)) = 3 )
    ( (cell-ref (cell 3)) = 3 )
    ( (let* ((my-cell (cell 5))
             (old-val (cell-ref my-cell)))
        (cell-set! my-cell 27)
        (list old-val (cell-ref my-cell)))
      ==> (5 27) )

    ( (let* ((c1 (cell 342))
             (c2 (cell 541))
             (c1-old (cell-ref c1))
             (c2-old (cell-ref c2)))
        (cell-swap! c1 c2)
        (list c1-old c2-old (cell-ref c1) (cell-ref c2)))
      ==> (342 541 541 342) )

    )
 )

