;;; $Id: double-size-mod.scm,v 1.2 2006/01/17 18:14:52 leavens Exp $
;;; AUTHOR: Gary T. Leavens

(module double-size-mod (lib "typedscm.ss" "typedscm")

(provide double-size)

(require (lib "window-layout-mod.scm" "lib342"))

(deftype double-size (-> (window-layout) window-layout))
(define double-size
  (lambda (layout)
    ;; ENSURES: result is the same as layout, but with all sizes doubled
    (cond
       ((window? layout) (window (window->name layout)
                                 (* 2 (window->width layout))
                                 (* 2 (window->height layout))))
       ((horizontal? layout)
        (horizontal (map (lambda (w) (double-size w))
                                (horizontal->subwindows layout))))
       (else ;; vertical case
         (vertical (map (lambda (w) (double-size w))
                              (vertical->subwindows layout)))))))
) ;; end module
