;;; $Id: double-size-mod.tst,v 1.3 2006/01/17 18:14:52 leavens Exp $

(require (lib "double-size-mod.scm" "lib342")
         (lib "window-layout-mod.scm" "lib342"))

(define complex-layout
       (parse-window-layout
        '(horizontal
            (vertical (window tempest 200 100)
                      (window othello 200 77)
                      (window hamlet 1000 600))
            (horizontal (window baseball 50 40)
                        (window track 100 60)
                        (window equesterian 70 30))
            (vertical (window star-trek 40 100)
                      (window olympics 80 33)
                      (window local-news 20 10)))))

(run-regression-tests-equal?
 `(

   ( (double-size (parse-window-layout '(window olympics 80 33)))
      = (parse-window-layout '(window olympics 160 66)) )
   ( (double-size (parse-window-layout
                      '(horizontal (window olympics 10 20)
                                   (window local-news 20 10))))
      = (parse-window-layout
         '(horizontal (window olympics 20 40)
                      (window local-news 40 20))) )
   ( (double-size (parse-window-layout  '(vertical )))
      = (parse-window-layout  '(vertical )) )
   ( (double-size (parse-window-layout
                   '(vertical (window olympics 10 20)
                              (window local-news 20 10))) )
      = (parse-window-layout
         '(vertical (window olympics 20 40)
                    (window local-news 40 20))) )
   ( (double-size complex-layout)
     = (parse-window-layout
        '(horizontal
          (vertical (window tempest 400 200)
                    (window othello 400 154)
                    (window hamlet 2000 1200))
          (horizontal (window baseball 100 80)
                      (window track 200 120)
                      (window equesterian 140 60))
          (vertical (window star-trek 80 200)
                    (window olympics 160 66)
                    (window local-news 40 20)))) )

    )
 )
