;;; $Id: lexical-addr-exp-mod.tst,v 1.2 2006/01/05 22:24:09 leavens Exp $

(require (lib "lexical-addr-exp-mod.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (lexical-addr-exp? (la:var-exp (lexical-addr 'x 3 4))) ==> #t )
    ( (lexical-addr-exp? (la:quote-exp 'x)) ==> #t )
    ( (lexical-addr-exp?
       (la:lambda-exp '(x y)
                      (la:if-exp (la:quote-exp 'z)
                                 (la:var-exp (lexical-addr 'x 0 0))
                                 (la:var-exp (lexical-addr 'y 0 1)))))
      ==> #t )
    ( (lexical-addr-exp?
       (la:app-exp
        (la:lambda-exp
         '(x y)
         (la:if-exp (la:quote-exp 'z)
                    (la:var-exp (lexical-addr 'x 0 0))
                    (la:var-exp (lexical-addr 'y 0 1))))
        (list (la:var-exp (lexical-addr 'z 2 3))
              (la:var-exp (lexical-addr 'q 2 0)))))
      ==> #t )

    ( (la:var-exp? (la:var-exp (lexical-addr 'x 0 0)))
      ==> #t )
    ( (la:quote-exp? (la:var-exp (lexical-addr 'x 0 0)))
      ==> #f )
    ( (la:lambda-exp? (la:var-exp (lexical-addr 'x 0 0)))
      ==> #f )
    ( (la:if-exp? (la:var-exp (lexical-addr 'x 0 0)))
      ==> #f )
    ( (la:app-exp? (la:var-exp (lexical-addr 'x 0 0)))
      ==> #f )

    ( (la:var-exp? (la:quote-exp 'z))
      ==> #f )
    ( (la:quote-exp? (la:quote-exp 'z))
      ==> #t )
    ( (la:lambda-exp? (la:quote-exp 'z))
      ==> #f )
    ( (la:if-exp? (la:quote-exp 'z))
      ==> #f )
    ( (la:app-exp? (la:quote-exp 'z))
      ==> #f )

    ( (la:var-exp? (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      ==> #f )
    ( (la:quote-exp? (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      ==> #f )
    ( (la:lambda-exp? (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      ==> #t )
    ( (la:if-exp? (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      ==> #f )
    ( (la:app-exp? (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      ==> #f )

    ( (la:var-exp? (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                              (la:var-exp (lexical-addr 'y 0 1))
                              (la:var-exp (lexical-addr 'z 0 0))))
      ==> #f )
    ( (la:quote-exp? (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                              (la:var-exp (lexical-addr 'y 0 1))
                              (la:var-exp (lexical-addr 'z 0 0))))
      ==> #f )
    ( (la:lambda-exp? (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                              (la:var-exp (lexical-addr 'y 0 1))
                              (la:var-exp (lexical-addr 'z 0 0))))
      ==> #f )
    ( (la:if-exp? (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                              (la:var-exp (lexical-addr 'y 0 1))
                              (la:var-exp (lexical-addr 'z 0 0))))
      ==> #t )
    ( (la:app-exp? (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                              (la:var-exp (lexical-addr 'y 0 1))
                              (la:var-exp (lexical-addr 'z 0 0))))
      ==> #f )

    ( (la:var-exp? (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                               (list (la:quote-exp 'z))))
      ==> #f )
    ( (la:quote-exp? (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                                 (list (la:quote-exp 'z))))
      ==> #f )
    ( (la:lambda-exp? (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                                  (list (la:quote-exp 'z))))
      ==> #f )
    ( (la:if-exp? (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                              (list (la:quote-exp 'z))))
      ==> #f )
    ( (la:app-exp? (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                               (list (la:quote-exp 'z))))
      ==> #t )

    ( (la:var-exp->lexical-addr (la:var-exp (lexical-addr 'x 0 0)))
      = (lexical-addr 'x 0 0) )

    ( (la:quote-exp->symbol (la:quote-exp 'z)) ==> z )

    ( (la:lambda-exp->ids
       (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      ==> (x) )

    ( (la:lambda-exp->body
       (la:lambda-exp '(x) (la:var-exp (lexical-addr 'x 0 0))))
      = (la:var-exp (lexical-addr 'x 0 0)) )

    ( (la:if-exp->test-exp
       (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                  (la:var-exp (lexical-addr 'y 0 1))
                  (la:var-exp (lexical-addr 'z 0 0))))
      = (la:var-exp (lexical-addr 'x 0 0)) )
    ( (la:if-exp->true-exp
       (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                  (la:var-exp (lexical-addr 'y 0 1))
                  (la:var-exp (lexical-addr 'z 0 0))))
      = (la:var-exp (lexical-addr 'y 0 1)) )
    ( (la:if-exp->false-exp
       (la:if-exp (la:var-exp (lexical-addr 'x 0 0))
                  (la:var-exp (lexical-addr 'y 0 1))
                  (la:var-exp (lexical-addr 'z 3 5))))
      = (la:var-exp (lexical-addr 'z 3 5)) )

    ( (la:app-exp->rator
       (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                   (list (la:quote-exp 'z))))
      = (la:var-exp (lexical-addr 'x 0 0)) )

    ( (la:app-exp->rands
       (la:app-exp (la:var-exp (lexical-addr 'x 0 0))
                   (list (la:quote-exp 'z))))
      = (list (la:quote-exp 'z)) )

    ( (parse-lexical-addr-exp
       '((lambda (x y) (if 'z (x : 0 0) (y : 0 1)))
         (z : 2 3) (q : 2 0)))
      = (la:app-exp
         (la:lambda-exp
          '(x y)
          (la:if-exp (la:quote-exp 'z)
                     (la:var-exp (lexical-addr 'x 0 0))
                     (la:var-exp (lexical-addr 'y 0 1))))
         (list (la:var-exp (lexical-addr 'z 2 3))
               (la:var-exp (lexical-addr 'q 2 0)))) )
    )
 )

