;; $Id: list-index-find.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $

(module list-index-find (lib "typedscm.ss" "typedscm")

(provide list-index find)

(deftype find (forall (T) (-> (T (list-of T) number) number)))
(deftype list-index (forall (T) (-> (T (list-of T)) number)))

(define find
  (lambda (s los index)
    ; ENSURES: if s occurs in los, returns index plus the zero-based index
    ; of the first occurrence of s in los, otherwise returns -1
    (if (null? los) 
        -1
        (if (eq? s (car los)) 
            index
            (find s (cdr los) (+ 1 index))))))

(define list-index
  (lambda (s los)
    ; ENSURES: if s occurs in los, returns the zero-based index of
    ; the first occurrence of s in los, otherwise returns -1
    (find s los 0)))

) ;; end module
