;;; $Id: phone-book-as-proc.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $
;;;---------------------------------------------------------------------
;;; An ADT for a simple phone book
;;;---------------------------------------------------------------------

;;;---------------------------------------------------------------------
;;; The declarations for the public (client-visible) interface of the
;;; phone book ADT
;;;---------------------------------------------------------------------

(module phone-book-as-proc (lib "typedscm.ss" "typedscm")

(provide create-empty-phone-book add-to-phone-book look-up)

(deftype create-empty-phone-book (-> () phone-book))
(deftype add-to-phone-book (-> (symbol number phone-book) phone-book))
(deftype look-up (-> (phone-book symbol) number))

;;;---------------------------------------------------------------------
;;; A procedural representation of the phone book ADT
;;;---------------------------------------------------------------------

(defrep (phone-book (-> (symbol) number)))

(define create-empty-phone-book
  (lambda ()
    (lambda (who)
      (error "no listing for" who))))

(define add-to-phone-book
  (lambda (name number old-book)
    (lambda (who)
      (if (eq? who name)
          number
          (old-book who)))))

(define look-up
  (lambda (book who)
    (book who)))

) ;; end module       
