;;; $Id: procval-as-proc.scm,v 1.4 2006/01/05 22:24:09 leavens Exp $
;;; adapted from 3-5.scm

;;;;;;;;;;;;;;;; procedures ;;;;;;;;;;;;;;;;

(module procval-as-proc (lib "typedscm.ss" "typedscm")

(provide procval? closure-maker apply-procval)

(deftype procval? (type-predicate-for procval))
(deftype closure-maker
  (-> ((-> (expression environment) Expressed-Value)
       (-> ((list-of symbol) (list-of Expressed-Value) environment)
            environment))
      (-> ((list-of symbol) expression environment) procval)))
(deftype apply-procval
  (-> (procval (list-of Expressed-Value)) Expressed-Value))

(defrep (procval (-> ((list-of Expressed-Value)) Expressed-Value)))

(define procval?
  (lambda (d)
    (procedure? d)))

(define closure-maker
  (lambda (eval-expression extend-env)
    (lambda (ids body env)
      (lambda (args)
        (eval-expression body (extend-env ids args env))))))

(define apply-procval
  (has-type-trusted
    (-> (procval (list-of Expressed-Value)) Expressed-Value)
    (lambda (proc args)
      (proc args))))

) ;; end module
