;;; $Id: standardize.scm,v 1.4 2006/01/18 23:17:27 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

;; testing, displayln, writeln
(require (lib "testing.scm" "typedscm"))

;; Some other things to make chez more like SCM and MzScheme
(print-vector-length #f)

(define current-error-port
  (let ((port (console-output-port)))  ; changed from current-output-port
    (lambda () port)))

(define chez:error error)
(define abort reset)

(define error
  (lambda args
    (let ((port (current-error-port)))
      (display "ERROR:" port)
      (for-each (lambda (x) (display " " port) (display x port)) args)
      (newline port)
      (abort))))

(define quit exit)

(define promise? procedure?)

(define collection-path
  (letrec ((separate
	    (lambda (path dirs)
	      (if (null? dirs)
		  path
		  (separate (string-append path "/" (car dirs))
			    (cdr dirs))))))
    (lambda args
      (separate *trms:collects-dir* args))))

(define force-output flush-output-port)

(define load-typedscm-chez
  (let ((tsc (string-append *trms:collects-dir* "/typedscm/chez/")))
    (lambda (fn)
      (load (string-append tsc fn)))))

;; load the EOPL init file
(load-typedscm-chez "chez-init.scm")

;; the type notation
(load-typedscm-chez "tc-ignore-types-at-runtime.scm")
