(define-datatype Expressed-Value expval?
  (number->expressed (num number?)))

(deftype print-value (-> (Expressed-Value) void))
(define print-value
  (lambda (ev)
    (cases Expressed-Value ev
      (number->expressed (num) (write num)))))

(deftype separate-with-c
  (forall (T) (-> (string (-> (T) void)) (-> ((list-of T)) void))))
(define separate-with-c
  (lambda (separator displayer)
    (lambda (lst)
      (for-each (lambda (x)
		  (displayer x)
		  (display separator))
		lst))))

;; Error below, the type of space-separate only works with lists of
;; expressed vlaues, not with everything.
;; N.B. the error goes away (i.e., the checker finds the type error)
;; if you leave out the following deftype!
(deftype space-separate (forall (T) (-> ((list-of T)) void)))
(define space-separate (separate-with-c " " print-value))

;; this shows it...
(newline)
(displayln "Now about to crash due to missed type error")
(space-separate (list 3 4))

;;; $Id: not-found-error.scm,v 1.2 2006/03/07 06:56:53 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.
